#include <jpeglib.h>
#undef EXTERN
#include <X11/Xlib.h>
#include <X11/X.h>

#define FORMAT_PGM      1
#define FORMAT_RAW8     2
#define FORMAT_JPG      3

typedef struct {
	int type; // 5=pgm, 6=ppm
	int pixelbytes;
	char *comment;
	int xsize,ysize;
	int numcols; 
	unsigned char *buf;
} FG_pnm;

int
FG_WriteJPEGFile (    JSAMPLE *image_buffer,
                        char *com,
                        int image_width,
                        int image_height,
                        FILE * outfile, 
                        int quality);

int FG_WritePnm(FG_pnm *pnm,FILE *file);
int FG_ReadPnm(FG_pnm *pnm,FILE *file);

int 
FG_TryGlobalCmap(Display *display,XColor tofind[],
                int num_cols,u_long pixeltab[]); 

void
FG_FindSimilarCmap(   Display *display,
			Colormap origmap,
			Colormap newmap,
			XColor tofind[],
			int num_cols,
			u_long pixeltab[]);

